# LogExpFunctions.jl

[![CI](https://github.com/JuliaStats/LogExpFunctions.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaStats/LogExpFunctions.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![codecov.io](http://codecov.io/github/JuliaStats/LogExpFunctions.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaStats/LogExpFunctions.jl?branch=master)
[![Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliastats.github.io/LogExpFunctions.jl/stable)
[![Documentation](https://img.shields.io/badge/docs-master-blue.svg)](https://juliastats.github.io/LogExpFunctions.jl/dev)

Various special functions based on `log` and `exp` moved from [StatsFuns.jl](https://github.com/JuliaStats/StatsFuns.jl) into a separate package, to minimize dependencies. These functions only use native Julia code, so there is no need to depend on `librmath` or similar libraries. See the discussion at [StatsFuns.jl#46](https://github.com/JuliaStats/StatsFuns.jl/issues/46).

The original authors of these functions are the StatsFuns.jl contributors.

module LogExpFunctions

using DocStringExtensions: SIGNATURES
using Base: Math.@horner

import IrrationalConstants
import LinearAlgebra

export xlogx, xlogy, xlog1py, xexpx, xexpy, logistic, logit, log1psq, log1pexp, log1mexp, log2mexp, logexpm1,
    softplus, invsoftplus, log1pmx, logmxp1, logaddexp, logsubexp, logsumexp, logsumexp!, softmax,
    softmax!, logcosh, logabssinh, logabstanh, cloglog, cexpexp,
    loglogistic, logitexp, log1mlogistic, logit1mexp

include("basicfuns.jl")
include("logsumexp.jl")

if !isdefined(Base, :get_extension)
    include("../ext/LogExpFunctionsChainRulesCoreExt.jl")
    include("../ext/LogExpFunctionsChangesOfVariablesExt.jl")
    include("../ext/LogExpFunctionsInverseFunctionsExt.jl")
end

end # module

module LogExpFunctionsChangesOfVariablesExt

using LogExpFunctions
import ChangesOfVariables
import LogExpFunctions.IrrationalConstants

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(log1pexp), x::Real)
    y = log1pexp(x)
    return y, x - y
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(logexpm1), x::Real)
    y = logexpm1(x)
    return y, x - y
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(log1mexp), x::Real)
    y = log1mexp(x)
    return y, x - y
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(log2mexp), x::Real)
    y = log2mexp(x)
    return y, x - y
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(logit), x::Real)
    y = logit(x)
    y, -log(x * (1 - x))
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(logistic), x::Real)
    y = logistic(x)
    y, log(y * (1 - y))
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(logcosh), x::Real)
    abs_x = abs(x)
    a = - 2 * abs_x
    z = log1pexp(a)
    y = abs_x + z - IrrationalConstants.logtwo
    return y, log1mexp(a) - z
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(loglogistic), x::Real)
    y = loglogistic(x)
    return y, y - x
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(log1mlogistic), x::Real)
    y = log1mlogistic(x)
    return y, x + y
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(logitexp), x::Real)
    y = logitexp(x)
    return y, y - x
end

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(logit1mexp), x::Real)
    y = logit1mexp(x)
    return y, -y - x
end

end # module

# scalar functions
"""
$(SIGNATURES)

Return `x * log(x)` for `x ≥ 0`, handling ``x = 0`` by taking the downward limit.

```jldoctest
julia> xlogx(0)
0.0
```
"""
function xlogx(x::Number)
    result = x * log(x)
    return iszero(x) ? zero(result) : result
end

"""
$(SIGNATURES)

Return `x * log(y)` for `y > 0` with correct limit at ``x = 0``.

```jldoctest
julia> xlogy(0, 0)
0.0
```
"""
function xlogy(x::Number, y::Number)
    result = x * log(y)
    return iszero(x) && !isnan(y) ? zero(result) : result
end

"""
$(SIGNATURES)

Return `x * log(1 + y)` for `y ≥ -1` with correct limit at ``x = 0``.

```jldoctest
julia> xlog1py(0, -1)
0.0
```
"""
function xlog1py(x::Number, y::Number)
    result = x * log1p(y)
    return iszero(x) && !isnan(y) ? zero(result) : result
end

"""
$(SIGNATURES)

Return `x * exp(x)` for `x > -Inf`, or zero if `x == -Inf`.

```jldoctest
julia> xexpx(-Inf)
0.0
```
"""
function xexpx(x::Real)
    expx = exp(x)
    return iszero(expx) ? expx : x * expx
end

"""
$(SIGNATURES)

Return `x * exp(y)` for `y > -Inf`, or zero if `y == -Inf` or if `x == 0` and `y` is finite.

```jldoctest
julia> xexpy(1.0, -Inf)
0.0
```
"""
function xexpy(x::Real, y::Real)
    expy = exp(y)
    result = x * expy
    return (iszero(x) && isfinite(y)) || (iszero(expy) && !isnan(x)) ? zero(result) : result
end

# The following bounds are precomputed versions of the following abstract
# function, but the implicit interface for AbstractFloat doesn't uniformly
# enforce that all floating point types implement nextfloat and prevfloat.
# @inline function _logistic_bounds(x::AbstractFloat)
#     (
#         logit(nextfloat(zero(float(x)))),
#         logit(prevfloat(one(float(x)))),
#     )
# end

@inline _logistic_bounds(x::Float16) = (Float16(-16.64), Float16(7.625))
@inline _logistic_bounds(x::Float32) = (-103.27893f0, 16.635532f0)
@inline _logistic_bounds(x::Float64) = (-744.4400719213812, 36.7368005696771)

"""
$(SIGNATURES)

The [logistic](https://en.wikipedia.org/wiki/Logistic_function) sigmoid function mapping a
real number to a value in the interval ``[0,1]``,

```math
\\sigma(x) = \\frac{1}{e^{-x} + 1} = \\frac{e^x}{1+e^x}.
```

Its inverse is the [`logit`](@ref) function.
"""
logistic(x::Real) = inv(exp(-x) + one(x))

function logistic(x::Union{Float16, Float32, Float64})
    e = exp(x)
    lower, upper = _logistic_bounds(x)
    return x < lower ? zero(x) : x > upper ? one(x) : e / (one(x) + e)
end

"""
$(SIGNATURES)

The [logit](https://en.wikipedia.org/wiki/Logit) or log-odds transformation, defined as
```math
\\operatorname{logit}(x) = \\log\\left(\\frac{x}{1-x}\\right)
```
for ``0 < x < 1``.

Its inverse is the [`logistic`](@ref) function.
"""
logit(x::Real) = log(x / (one(x) - x))

"""
$(SIGNATURES)

Return `log(cosh(x))`, carefully evaluated without intermediate calculation of `cosh(x)`.

The implementation ensures `logcosh(-x) = logcosh(x)`.
"""
function logcosh(x::Real)
    abs_x = abs(x)
    return abs_x + log1pexp(- 2 * abs_x) - IrrationalConstants.logtwo
end

"""
$(SIGNATURES)

Return `log(abs(sinh(x)))`, carefully evaluated without intermediate calculation of `sinh(x)`.

The implementation ensures `logabssinh(-x) = logabssinh(x)`.
"""
function logabssinh(x::Real)
    abs_x = abs(x)
    return abs_x + log1mexp(- 2 * abs_x) - IrrationalConstants.logtwo
end

"""
$(SIGNATURES)

Return `log(1+x^2)` evaluated carefully for `abs(x)` very small or very large.
"""
log1psq(x::Real) = log1p(abs2(x))
function log1psq(x::Union{Float32,Float64})
    ax = abs(x)
    ax < maxintfloat(x) ? log1p(abs2(ax)) : 2 * log(ax)
end

"""
$(SIGNATURES)

Return `log(1+exp(x))` evaluated carefully for largish `x`.

This is also called the ["softplus"](https://en.wikipedia.org/wiki/Rectifier_(neural_networks))
transformation, being a smooth approximation to `max(0,x)`. Its inverse is [`logexpm1`](@ref).

See:
 * Martin Maechler (2012) [“Accurately Computing log(1 − exp(− |a|))”](http://cran.r-project.org/web/packages/Rmpfr/vignettes/log1mexp-note.pdf)
"""
log1pexp(x::Real) = _log1pexp(float(x)) # ensures that BigInt/BigFloat, Int/Float64 etc. dispatch to the same algorithm

# Approximations based on Maechler (2012)
# Argument `x` is a floating point number due to the definition of `log1pexp` above
function _log1pexp(x::Real)
    x1, x2, x3, x4 = _log1pexp_thresholds(x)
    if x < x1
        return zero(x)
    elseif x < x2
        return exp(x)
    elseif x < x3
        return log1p(exp(x))
    elseif x < x4
        return x + exp(-x)
    else
        return x
    end
end

#= The precision of BigFloat cannot be computed from the type only and computing
thresholds is slow. Therefore prefer version without thresholds in this case. =#
_log1pexp(x::BigFloat) = x > 0 ? x + log1p(exp(-x)) : log1p(exp(x))

#=
Returns thresholds x1, x2, x3, x4 such that:
    * log1pexp(x) = 0 for x < x1
    * log1pexp(x) ≈ exp(x) for x < x2
    * log1pexp(x) ≈ log1p(exp(x)) for x2 ≤ x < x3
    * log1pexp(x) ≈ x + exp(-x) for x3 ≤ x < x4
    * log1pexp(x) ≈ x for x ≥ x4

where the tolerances of the approximations are on the order of eps(typeof(x)).
For types for which `precision(x)` depends only on the type of `x`, the compiler
should optimize away all computations done here.
=#
@inline function _log1pexp_thresholds(x::Real)
    prec = precision(x)
    logtwo = oftype(x, IrrationalConstants.logtwo)
    x1 = (exponent(nextfloat(zero(x))) - 1) * logtwo
    x2 = -prec * logtwo
    x3 = (prec - 1) * logtwo / 2
    x4 = -x2 - log(-x2) * (1 + 1 / x2) # approximate root of e^-x == x * ϵ/2 via asymptotics of Lambert's W function
    return (x1, x2, x3, x4)
end

#=
For common types we hard-code the thresholds to make absolutely sure they are not recomputed
each time. Also, _log1pexp_thresholds is not elided by the compiler in Julia 1.0 / 1.6.
=#
@inline _log1pexp_thresholds(::Float64) = (-745.1332191019412, -36.7368005696771, 18.021826694558577, 33.23111882352963)
@inline _log1pexp_thresholds(::Float32) = (-103.97208f0, -16.635532f0, 7.9711924f0, 13.993f0)
@inline _log1pexp_thresholds(::Float16) = (Float16(-17.33), Float16(-7.625), Float16(3.467), Float16(5.86))

"""
$(SIGNATURES)

Return `log(1 - exp(x))`

See:
 * Martin Maechler (2012) [“Accurately Computing log(1 − exp(− |a|))”](http://cran.r-project.org/web/packages/Rmpfr/vignettes/log1mexp-note.pdf)

Note: different than Maechler (2012), no negation inside parentheses
"""
function log1mexp(x::Real)
    # Use explicit `oftype(..)` instead of just `loghalf` to avoid CUDA issues:
    # https://github.com/JuliaStats/LogExpFunctions.jl/issues/73
    if x < oftype(float(x), IrrationalConstants.loghalf)
        return log1p(-exp(x))
    else
        return log(-_expm1(x))
    end
end

"""
$(SIGNATURES)

Return `log(2 - exp(x))` evaluated as `log1p(-expm1(x))`
"""
log2mexp(x::Real) = log1p(-_expm1(x))

"""
$(SIGNATURES)

Return `log(exp(x) - 1)` or the “invsoftplus” function.  It is the inverse of
[`log1pexp`](@ref) (aka “softplus”).
"""
logexpm1(x::Real) = x <= 18.0 ? log(_expm1(x)) : x <= 33.3 ? x - exp(-x) : oftype(exp(-x), x)
logexpm1(x::Float32) = x <= 9f0 ? log(expm1(x)) : x <= 16f0 ? x - exp(-x) : oftype(exp(-x), x)

const softplus = log1pexp
const invsoftplus = logexpm1

"""
$(SIGNATURES)

Return `log(1 + x) - x`.

Use naive calculation or range reduction outside kernel range.  Accurate ~2ulps for all `x`.
This will fall back to the naive calculation for argument types different from `Float64`.
"""
function log1pmx(x::Float64)
    if !(-0.7 < x < 0.9)
        return log1p(x) - x
    elseif x > 0.315
        u = (x-0.5)/1.5
        return _log1pmx_ker(u) - 9.45348918918356180e-2 - 0.5*u
    elseif x > -0.227
        return _log1pmx_ker(x)
    elseif x > -0.4
        u = (x+0.25)/0.75
        return _log1pmx_ker(u) - 3.76820724517809274e-2 + 0.25*u
    elseif x > -0.6
        u = (x+0.5)*2.0
        return _log1pmx_ker(u) - 1.93147180559945309e-1 + 0.5*u
    else
        u = (x+0.625)/0.375
        return _log1pmx_ker(u) - 3.55829253011726237e-1 + 0.625*u
    end
end

# Naive fallback
log1pmx(x::Real) = log1p(x) - x

"""
$(SIGNATURES)

Return `log(x) - x + 1` carefully evaluated.
This will fall back to the naive calculation for argument types different from `Float64`.
"""
function logmxp1(x::Float64)
    if x <= 0.3
        return (log(x) + 1.0) - x
    elseif x <= 0.4
        u = (x-0.375)/0.375
        return _log1pmx_ker(u) - 3.55829253011726237e-1 + 0.625*u
    elseif x <= 0.6
        u = 2.0*(x-0.5)
        return _log1pmx_ker(u) - 1.93147180559945309e-1 + 0.5*u
    else
        return log1pmx(x - 1.0)
    end
end

# Naive fallback
function logmxp1(x::Real)
    one_x = one(x)
    if 2 * x < one_x
        # for small values of `x` the other branch returns non-finite values
        return (log(x) + one_x) - x
    else
        return log1pmx(x - one_x)
    end
end

# The kernel of log1pmx
# Accuracy within ~2ulps for -0.227 < x < 0.315
function _log1pmx_ker(x::Float64)
    r = x/(x+2.0)
    t = r*r
    w = @horner(t,
                6.66666666666666667e-1, # 2/3
                4.00000000000000000e-1, # 2/5
                2.85714285714285714e-1, # 2/7
                2.22222222222222222e-1, # 2/9
                1.81818181818181818e-1, # 2/11
                1.53846153846153846e-1, # 2/13
                1.33333333333333333e-1, # 2/15
                1.17647058823529412e-1) # 2/17
    hxsq = 0.5*x*x
    r*(hxsq+w*t)-hxsq
end


"""
$(SIGNATURES)

Return `log(exp(x) + exp(y))`, avoiding intermediate overflow/undeflow, and handling
non-finite values.
"""
function logaddexp(x::Real, y::Real)
    # Compute max = Base.max(x, y) and diff = x == y ? zero(x - y) : -abs(x - y)
    # in a faster type-stable way
    a, b = promote(x, y)
    if a < b
        diff = a - b
        max = b
    else
        # ensure diff = 0 if a = b = ± Inf
        diff = a == b ? zero(a - b) : b - a
        max = !isnan(b) ? a : b
    end
    return max + log1pexp(diff)
end

Base.@deprecate logsumexp(x::Real, y::Real) logaddexp(x, y)

"""
$(SIGNATURES)

Return `log(abs(exp(x) - exp(y)))`, preserving numerical accuracy.
"""
function logsubexp(x::Real, y::Real)
    # ensure that `Δ = 0` if `x = y = - Inf` (but not for `x = y = +Inf`!)
    Δ = x == y && (isfinite(x) || x < 0) ? zero(x - y) : abs(x - y)
    return max(x, y) + log1mexp(-Δ)
end

"""
    softmax!(r::AbstractArray{<:Real}, x::AbstractArray{<:Real}=r; dims=:)

Overwrite `r` with the
[softmax transformation](https://en.wikipedia.org/wiki/Softmax_function) of `x` over
dimension `dims`.

That is, `r` is overwritten with `exp.(x)`, normalized to sum to 1 over the given
dimensions.

See also: [`softmax`](@ref)
"""
softmax!(r::AbstractArray{<:Real}, x::AbstractArray{<:Real}=r; dims=:) =
    _softmax!(r, x, dims)

"""
    softmax(x::AbstractArray{<:Real}; dims=:)

Return the
[softmax transformation](https://en.wikipedia.org/wiki/Softmax_function) of `x` over
dimension `dims`.

That is, return `exp.(x)`, normalized to sum to 1 over the given dimensions.

See also: [`softmax!`](@ref)
"""
softmax(x::AbstractArray{<:Real}; dims=:) =
    softmax!(similar(x, float(eltype(x))), x; dims=dims)

function _softmax!(r, x, ::Colon)
    length(r) == length(x) || throw(DimensionMismatch("inconsistent array lengths"))
    u = maximum(x)
    map!(r, x) do xi
        return exp(xi - u)
    end
    LinearAlgebra.lmul!(inv(sum(r)), r)
    return r
end

function _softmax!(r, x, dims)
    size(r) == size(x) || throw(DimensionMismatch("inconsistent array sizes"))
    u = maximum(x; dims=dims)
    r .= exp.(x .- u)
    if u isa Array{eltype(r)}
        # array can be reused
        sum!(u, r)
        r ./= u
    else
        r ./= sum(r; dims=dims)
    end
    return r
end

"""
$(SIGNATURES)

Compute the complementary log-log, `log(-log(1 - x))`.
"""
cloglog(x) = log(-log1p(-x))

"""
$(SIGNATURES)

Compute the complementary double exponential, `1 - exp(-exp(x))`.
"""
cexpexp(x) = -_expm1(-exp(x))

#=
this uses the identity:

log(logistic(x)) = -log(1 + exp(-x))
=#
"""
$(SIGNATURES)

Return `log(logistic(x))`, computed more carefully and with fewer calls
than the naive composition of functions.

Its inverse is the [`logitexp`](@ref) function.
"""
loglogistic(x::Real) = -log1pexp(-float(x))

#=
this uses the identity:

logit(exp(x)) = log(exp(x) / (1 + exp(x))) = -log(exp(-x) - 1)
=#
"""
$(SIGNATURES)

Return `logit(exp(x))`, computed more carefully and with fewer calls than
the naive composition of functions.

Its inverse is the [`loglogistic`](@ref) function.
"""
logitexp(x::Real) = -logexpm1(-float(x))

#=
this uses the identity:

log(logistic(-x)) = -log(1 + exp(x))

that is, negation in the log-odds domain.
=#

"""
$(SIGNATURES)

Return `log(1 - logistic(x))`, computed more carefully and with fewer calls than
the naive composition of functions.

Its inverse is the [`logit1mexp`](@ref) function.
"""
log1mlogistic(x::Real) = -log1pexp(x)

#=

this uses the same identity:

-logit(exp(x)) = logit(1 - exp(x)) = log((1 - exp(x)) / exp(x)) = log(exp(-x) - 1)
=#

"""
$(SIGNATURES)

Return `logit(1 - exp(x))`, computed more carefully and with fewer calls than
the naive composition of functions.

Its inverse is the [`log1mlogistic`](@ref) function.
"""
logit1mexp(x::Real) = logexpm1(-float(x))

module LogExpFunctionsChainRulesCoreExt

using LogExpFunctions
import ChainRulesCore

import LogExpFunctions.LinearAlgebra

function _Ω_∂_xlogx(x::Real)
    logx = log(x)
    y = x * logx
    Ω = iszero(x) ? zero(y) : y
    ∂x = 1 + logx
    return Ω, ∂x
end
function ChainRulesCore.frule((_, Δx), ::typeof(xlogx), x::Real)
    Ω, ∂x = _Ω_∂_xlogx(x)
    ΔΩ = ∂x * Δx
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(xlogx), x::Real)
    Ω, ∂x = _Ω_∂_xlogx(x)
    xlogx_pullback(ΔΩ) = (ChainRulesCore.NoTangent(), ∂x * ΔΩ)
    return Ω, xlogx_pullback
end

function _Ω_∂_xlogy(x::Real, y::Real)
    logy = log(y)
    z = x * logy
    w = x / y
    if iszero(x) && !isnan(y)
        Ω = zero(z)
        ∂y = zero(w)
    else
        Ω = z
        ∂y = w
    end
    ∂x = logy
    return Ω, ∂x, ∂y
end
function ChainRulesCore.frule((_, Δx, Δy), ::typeof(xlogy), x::Real, y::Real)
    Ω, ∂x, ∂y = _Ω_∂_xlogy(x, y)
    ΔΩ = muladd(∂x, Δx, ∂y * Δy)
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(xlogy), x::Real, y::Real)
    Ω, ∂x, ∂y = _Ω_∂_xlogy(x, y)
    xlogy_pullback(ΔΩ) = (ChainRulesCore.NoTangent(), ∂x * ΔΩ, ∂y * ΔΩ)
    return Ω, xlogy_pullback
end

function _Ω_∂_xlog1py(x::Real, y::Real)
    log1py = log1p(y)
    z = x * log1py
    w = x / (1 + y)
    if iszero(x) && !isnan(y)
        Ω = zero(z)
        ∂y = zero(w)
    else
        Ω = z
        ∂y = w
    end
    ∂x = log1py
    return Ω, ∂x, ∂y
end
function ChainRulesCore.frule((_, Δx, Δy), ::typeof(xlog1py), x::Real, y::Real)
    Ω, ∂x, ∂y = _Ω_∂_xlog1py(x, y)
    ΔΩ = muladd(∂x, Δx, ∂y * Δy)
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(xlog1py), x::Real, y::Real)
    Ω, ∂x, ∂y = _Ω_∂_xlog1py(x, y)
    xlog1py_pullback(ΔΩ) = (ChainRulesCore.NoTangent(), ∂x * ΔΩ, ∂y * ΔΩ)
    return Ω, xlog1py_pullback
end

function _Ω_∂_xexpx(x::Real)
    expx = exp(x)
    if iszero(expx)
        Ω = expx
        ∂x = expx
    else
        Ω = x * expx
        ∂x = (1 + x) * expx
    end
    return Ω, ∂x
end
function ChainRulesCore.frule((_, Δx), ::typeof(xexpx), x::Real)
    Ω, ∂x = _Ω_∂_xexpx(x)
    ΔΩ = ∂x * Δx
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(xexpx), x::Real)
    Ω, ∂x = _Ω_∂_xexpx(x)
    xexpx_pullback(ΔΩ) = (ChainRulesCore.NoTangent(), ∂x * ΔΩ)
    return Ω, xexpx_pullback
end

function _Ω_∂_xexpy(x::Real, y::Real)
    expy = exp(y)
    result = x * expy
    Ω = iszero(expy) && !isnan(x) ? zero(result) : result
    ∂x = expy
    ∂y = Ω
    return Ω, ∂x, ∂y
end
function ChainRulesCore.frule((_, Δx, Δy), ::typeof(xexpy), x::Real, y::Real)
    Ω, ∂x, ∂y = _Ω_∂_xexpy(x, y)
    ΔΩ = muladd(∂x, Δx, ∂y * Δy)
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(xexpy), x::Real, y::Real)
    Ω, ∂x, ∂y = _Ω_∂_xexpy(x, y)
    xexpy_pullback(ΔΩ) = (ChainRulesCore.NoTangent(), ∂x * ΔΩ, ∂y * ΔΩ)
    return Ω, xexpy_pullback
end

ChainRulesCore.@scalar_rule(logistic(x::Real), (Ω * (1 - Ω),))
ChainRulesCore.@scalar_rule(logit(x::Real), (inv(x * (1 - x)),))
ChainRulesCore.@scalar_rule(logcosh(x::Real), tanh(x))
ChainRulesCore.@scalar_rule(logabssinh(x::Real), coth(x))
ChainRulesCore.@scalar_rule(log1psq(x::Real), (2 * x / (1 + x^2),))
ChainRulesCore.@scalar_rule(log1pexp(x::Real), (logistic(x),))
ChainRulesCore.@scalar_rule(log1mexp(x::Real), (-exp(x - Ω),))
ChainRulesCore.@scalar_rule(log2mexp(x::Real), (-exp(x - Ω),))
ChainRulesCore.@scalar_rule(logexpm1(x::Real), (exp(x - Ω),))
ChainRulesCore.@scalar_rule(log1pmx(x::Real), (-x / (x + 1),))
ChainRulesCore.@scalar_rule(logmxp1(x::Real), ((1 - x) / x,))

ChainRulesCore.@scalar_rule(logaddexp(x::Real, y::Real), (exp(x - Ω), exp(y - Ω)))
ChainRulesCore.@scalar_rule(
    logsubexp(x::Real, y::Real),
    (x > y ? exp(x - Ω) : -exp(x - Ω), x > y ? -exp(y - Ω) : exp(y - Ω)),
)

function ChainRulesCore.frule((_, Δx), ::typeof(logsumexp), x::AbstractArray{<:Real}; dims=:)
    Ω = logsumexp(x; dims=dims)
    ΔΩ = sum(exp.(x .- Ω) .* Δx; dims=dims)
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(logsumexp), x::AbstractArray{<:Real}; dims=:)
    Ω = logsumexp(x; dims=dims)
    project_x = ChainRulesCore.ProjectTo(x)
    function logsumexp_pullback(Ω̄)
        x̄ = ChainRulesCore.InplaceableThunk(
            Δ -> Δ .+= Ω̄ .* exp.(x .- Ω),
            ChainRulesCore.@thunk(project_x(Ω̄ .* exp.(x .- Ω))),
        )
        return ChainRulesCore.NoTangent(), x̄
    end
    return Ω, logsumexp_pullback
end

# no rules for mutating functions currently:
# https://juliadiff.org/ChainRulesCore.jl/stable/writing_good_rules.html#Which-functions-need-rules?
function ChainRulesCore.frule((_, Δx), ::typeof(softmax), x::AbstractArray{<:Real}; dims=:)
    Ω = softmax(x; dims=dims)
    ΔΩ = if dims === (:)
        Ω .* (Δx .- LinearAlgebra.dot(Ω, Δx))
    else
        ΩΔx = Ω .* Δx
        ΩΔx .- Ω .* sum(ΩΔx; dims=dims)
    end
    return Ω, ΔΩ
end
function ChainRulesCore.rrule(::typeof(softmax), x::AbstractArray{<:Real}; dims=:)
    Ω = softmax(x; dims=dims)
    Ωcopy = copy(Ω)
    project_x = ChainRulesCore.ProjectTo(x)
    function softmax_pullback(Ω̄)
        x̄ = if dims === (:)
            ChainRulesCore.InplaceableThunk(
                Δ -> Δ .+= Ωcopy .* (Ω̄ .- LinearAlgebra.dot(Ωcopy, Ω̄)),
                ChainRulesCore.@thunk(project_x(Ωcopy .* (Ω̄ .- LinearAlgebra.dot(Ωcopy, Ω̄)))),
            )
        else
            ΩcopyΩ̄  = Ωcopy .* Ω̄
            ChainRulesCore.InplaceableThunk(
                Δ -> Δ .+= ΩcopyΩ̄  .- Ωcopy .* sum(ΩcopyΩ̄; dims=dims),
                ChainRulesCore.@thunk(project_x(ΩcopyΩ̄  .- Ωcopy .* sum(ΩcopyΩ̄; dims=dims))),
            )
        end
        return ChainRulesCore.NoTangent(), x̄
    end
    return Ω, softmax_pullback
end

ChainRulesCore.@scalar_rule(cloglog(x), (-inv((1 - x) * log1p(-x)),))
ChainRulesCore.@scalar_rule(cexpexp(x), (-xexpx(-exp(x)),))

end # module

####
#### Coverage summary, printed as "(percentage) covered".
####
#### Useful for CI environments that just want a summary (eg a Gitlab setup).
####

using Coverage
cd(joinpath(@__DIR__, "..", "..")) do
    covered_lines, total_lines = get_summary(process_folder())
    percentage = covered_lines / total_lines * 100
    println("($(percentage)%) covered")
end

using LogExpFunctions
using ChainRulesTestUtils
using ChainRulesCore
using ChangesOfVariables
using FiniteDifferences
using ForwardDiff
using InverseFunctions
using OffsetArrays

using Random
using Test

Random.seed!(1234)

include("basicfuns.jl")
include("chainrules.jl")
include("inverse.jl")
include("with_logabsdet_jacobian.jl")

module ULPError

export ulp_error, ulp_error_maximum

function ulp_error(accurate::AbstractFloat, approximate::AbstractFloat)
    # the ULP error is usually not required to great accuracy, so `Float32` should be precise enough
    zero_return = 0f0
    inf_return = Inf32
    # handle floating-point edge cases
    if !(isfinite(accurate) && isfinite(approximate))
        accur_is_nan = isnan(accurate)
        approx_is_nan = isnan(approximate)
        if accur_is_nan || approx_is_nan
            return if accur_is_nan === approx_is_nan
                zero_return
            else
                inf_return
            end
        end
        if isinf(approximate)
            return if isinf(accurate) && (signbit(accurate) == signbit(approximate))
                zero_return
            else
                inf_return
            end
        end
    end
    acc = if accurate isa Union{Float16, Float32}
        # widen for better accuracy when doing so does not impact performance too much
        widen(accurate)
    else
        accurate
    end
    abs(Float32((approximate - acc) / eps(approximate))::Float32)
end

function ulp_error(accurate, approximate, x::AbstractFloat)
    acc = accurate(x)
    app = approximate(x)
    ulp_error(acc, app)
end

function ulp_error(func::Func, x::AbstractFloat) where {Func}
    ulp_error(func ∘ BigFloat, func, x)
end

function ulp_error_maximum(func::Func, iterator) where {Func}
    maximum(Base.Fix1(ulp_error, func), iterator)
end

end

@testset "inverse.jl" begin
    InverseFunctions.test_inverse(log1pexp, randn())
    InverseFunctions.test_inverse(logexpm1, randexp())

    InverseFunctions.test_inverse(log1mexp, -randexp())

    InverseFunctions.test_inverse(log2mexp, log(2) - randexp())

    InverseFunctions.test_inverse(logistic, randn())
    InverseFunctions.test_inverse(logit, rand())

    InverseFunctions.test_inverse(cloglog, rand())
    InverseFunctions.test_inverse(cexpexp, rand())

    InverseFunctions.test_inverse(loglogistic, randexp())
    InverseFunctions.test_inverse(logitexp, -randexp())

    InverseFunctions.test_inverse(log1mlogistic, randexp())
    InverseFunctions.test_inverse(logit1mexp, -randexp())
end

"""
$(SIGNATURES)

Compute `log(sum(exp, X))`.

`X` should be an iterator of real or complex numbers.
The result is computed in a numerically stable way that avoids intermediate over- and underflow, using a single pass over the data.

See also [`logsumexp!`](@ref).

# References

[Sebastian Nowozin: Streaming Log-sum-exp Computation](http://www.nowozin.net/sebastian/blog/streaming-log-sum-exp-computation.html)
"""
logsumexp(X) = _logsumexp_onepass(X)

"""
$(SIGNATURES)

Compute `log.(sum(exp.(X); dims=dims))`.

The result is computed in a numerically stable way that avoids intermediate over- and underflow, using a single pass over the data.

See also [`logsumexp!`](@ref).

# References

[Sebastian Nowozin: Streaming Log-sum-exp Computation](http://www.nowozin.net/sebastian/blog/streaming-log-sum-exp-computation.html)
"""
logsumexp(X::AbstractArray{<:Number}; dims=:) = _logsumexp(X, dims)

"""
$(SIGNATURES)

Compute [`logsumexp`](@ref) of `X` over the singleton dimensions of `out`, and write results to `out`.

The result is computed in a numerically stable way that avoids intermediate over- and underflow, using a single pass over the data.

See also [`logsumexp`](@ref).

# References

[Sebastian Nowozin: Streaming Log-sum-exp Computation](http://www.nowozin.net/sebastian/blog/streaming-log-sum-exp-computation.html)
"""
function logsumexp!(out::AbstractArray, X::AbstractArray{<:Number})
    FT = float(eltype(X))
    xmax_r = fill!(similar(out, Tuple{FT,FT}), (FT(-Inf), zero(FT)))
    Base.reducedim!(_logsumexp_onepass_op, xmax_r, X)
    return @. out = first(xmax_r) + log1p(last(xmax_r))
end

_logsumexp(X::AbstractArray{<:Number}, ::Colon) = _logsumexp_onepass(X)
function _logsumexp(X::AbstractArray{<:Number}, dims)
    # Do not use log(zero(eltype(X))) directly to avoid issues with ForwardDiff (#82)
    FT = float(eltype(X))
    xmax_r = reduce(_logsumexp_onepass_op, X; dims=dims, init=(FT(-Inf), zero(FT)))
    return @. first(xmax_r) + log1p(last(xmax_r))
end

function _logsumexp_onepass(X)
    # fallback for empty collections
    isempty(X) && return log(sum(X))
    return _logsumexp_onepass_result(_logsumexp_onepass_reduce(X, Base.IteratorEltype(X)))
end

# function barrier for reductions with single element and without initial element
_logsumexp_onepass_result(x) = float(x)
_logsumexp_onepass_result((xmax, r)::Tuple) = xmax + log1p(r)

# iterables with known element type
function _logsumexp_onepass_reduce(X, ::Base.HasEltype)
    # do not perform type computations if element type is abstract
    T = eltype(X)
    isconcretetype(T) || return _logsumexp_onepass_reduce(X, Base.EltypeUnknown())

    FT = float(T)
    return reduce(_logsumexp_onepass_op, X; init=(FT(-Inf), zero(FT)))
end

# iterables without known element type
_logsumexp_onepass_reduce(X, ::Base.EltypeUnknown) = reduce(_logsumexp_onepass_op, X)

## Reductions for one-pass algorithm: avoid expensive multiplications if numbers are reduced

# reduce two numbers
function _logsumexp_onepass_op(x1::T, x2::T) where {T<:Number}
    xmax, a = if isnan(x1) || isnan(x2)
        # ensure that `NaN` is propagated correctly for complex numbers
        z = oftype(x1, NaN)
        z, exp(z)
    else
        real_x1 = real(x1)
        real_x2 = real(x2)
        if real_x1 > real_x2
            x1, x2 - x1
        elseif real_x1 < real_x2
            x2, x1 - x2
        else
            # handle `x1 = x2 = ±Inf` correctly
            # checking inequalities above instead of equality fixes issue #59
            x2, zero(x1 - x2)
        end
    end
    r = exp(a)
    return xmax, r
end
_logsumexp_onepass_op(x1::Number, x2::Number) = _logsumexp_onepass_op(promote(x1, x2)...)

# reduce a number and a partial sum
_logsumexp_onepass_op(x::Number, (xmax, r)::Tuple{<:Number,<:Number}) =
    _logsumexp_onepass_op(x, xmax, r)
_logsumexp_onepass_op((xmax, r)::Tuple{<:Number,<:Number}, x::Number) =
    _logsumexp_onepass_op(x, xmax, r)
_logsumexp_onepass_op(x::Number, xmax::Number, r::Number) =
    _logsumexp_onepass_op(promote(x, xmax)..., r)
function _logsumexp_onepass_op(x::T, xmax::T, r::Number) where {T<:Number}
    _xmax, _r = if isnan(x) || isnan(xmax)
        # ensure that `NaN` is propagated correctly for complex numbers
        z = oftype(x, NaN)
        z, r + exp(z)
    else
        real_x = real(x)
        real_xmax = real(xmax)
        if real_x > real_xmax
            x, (r + one(r)) * exp(xmax - x)
        elseif real_x < real_xmax
            xmax, r + exp(x - xmax)
        else
            # handle `x = xmax = ±Inf` correctly
            # checking inequalities above instead of equality fixes issue #59
            xmax, r + exp(zero(x - xmax))
        end
    end
    return _xmax, _r
end

# reduce two partial sums
function _logsumexp_onepass_op(
    (xmax1, r1)::Tuple{<:Number,<:Number}, (xmax2, r2)::Tuple{<:Number,<:Number}
)
    return _logsumexp_onepass_op(xmax1, xmax2, r1, r2)
end
function _logsumexp_onepass_op(xmax1::Number, xmax2::Number, r1::Number, r2::Number)
    return _logsumexp_onepass_op(promote(xmax1, xmax2)..., promote(r1, r2)...)
end
function _logsumexp_onepass_op(xmax1::T, xmax2::T, r1::R, r2::R) where {T<:Number,R<:Number}
    xmax, r = if isnan(xmax1) || isnan(xmax2)
        # ensure that `NaN` is propagated correctly for complex numbers
        z = oftype(xmax1, NaN)
        z, r1 + exp(z)
    else
        real_xmax1 = real(xmax1)
        real_xmax2 = real(xmax2)
        if real_xmax1 > real_xmax2
            xmax1, r1 + (r2 + one(r2)) * exp(xmax2 - xmax1)
        elseif real_xmax1 < real_xmax2
            xmax2, r2 + (r1 + one(r1)) * exp(xmax1 - xmax2)
        else
            # handle `xmax1 = xmax2 = ±Inf` correctly
            # checking inequalities above instead of equality fixes issue #59
            xmax2, r2 + (r1 + one(r1)) * exp(zero(xmax1 - xmax2))
        end
    end
    return xmax, r
end

@testset "xlogx, xlogy, and xlog1py" begin
    @test iszero(xlogx(0))
    @test xlogx(2) ≈ 2.0 * log(2.0)
    @test_throws DomainError xlogx(-1)
    @test isnan(xlogx(NaN))

    @test iszero(xlogy(0, 1))
    @test xlogy(2, 3) ≈ 2.0 * log(3.0)
    @test_throws DomainError xlogy(1, -1)
    @test isnan(xlogy(NaN, 2))
    @test isnan(xlogy(2, NaN))
    @test isnan(xlogy(0, NaN))

    @test iszero(xlog1py(0, 0))
    @test xlog1py(2, 3) ≈ 2.0 * log1p(3.0)
    @test_throws DomainError xlog1py(1, -2)
    @test isnan(xlog1py(NaN, 2))
    @test isnan(xlog1py(2, NaN))
    @test isnan(xlog1py(0, NaN))

    # Since we allow complex/negative values, test for them. See comments in:
    # https://github.com/JuliaStats/StatsFuns.jl/pull/95

    @test xlogx(1 + im) == (1 + im) * log(1 + im)
    @test isnan(xlogx(NaN + im))
    @test isnan(xlogx(1 + NaN * im))

    @test xlogy(-2, 3) == -xlogy(2, 3)
    @test xlogy(1 + im, 3) == (1 + im) * log(3)
    @test xlogy(1 + im, 2 + im) == (1 + im) * log(2 + im)
    @test isnan(xlogy(1 + NaN * im, -1 + im))
    @test isnan(xlogy(0, -1 + NaN * im))
    @test isnan(xlogy(Inf + im * NaN, 1))
    @test isnan(xlogy(0 + im * 0, NaN))
    @test iszero(xlogy(0 + im * 0, 0 + im * Inf))

    @test xlog1py(-2, 3) == -xlog1py(2, 3)
    @test xlog1py(1 + im, 3) == (1 + im) * log1p(3)
    @test xlog1py(1 + im, 2 + im) == (1 + im) * log1p(2 + im)
    @test isnan(xlog1py(1 + NaN * im, -1 + im))
    @test isnan(xlog1py(0, -1 + NaN * im))
    @test isnan(xlog1py(Inf + im * NaN, 1))
    @test isnan(xlog1py(0 + im * 0, NaN))
    @test iszero(xlog1py(0 + im * 0, -1 + im * Inf))
end

@testset "xexpx" begin
    for x in (false, 0, 0.0, 0f0, -Inf, -Inf32)
        @test (@inferred xexpx(x)) === zero(exp(x))
    end
    for x in (NaN16, NaN32, NaN64, Inf16, Inf32, Inf64)
        @test (@inferred xexpx(x)) === x
    end
    for x in (1, true, 1.0, 1f0)
        @test (@inferred xexpx(x)) === exp(x)
    end
    for a in (2, 2f0, 2.0), x in -a:a
        @test (@inferred xexpx(x)) === x * exp(x)
    end
end

@testset "xexpy" begin
    for x in (0, 1, 1.0, 1f0, Inf, Inf32), y in (-Inf, -Inf32)
        @test (@inferred xexpy(x, y)) === zero(x * exp(y))
    end
    for x in (0, 1, 1.0, 1f0, Inf, Inf32, -Inf, -Inf32, NaN, NaN32), nan in (NaN, NaN32)
        @test (@inferred xexpy(x, nan)) === oftype(x * exp(nan), NaN)
        @test (@inferred xexpy(nan, x)) === oftype(nan * exp(x), NaN)
    end
    for x in (2, -2f0, 2.0), y in (1, -1f0, 1.0)
        @test (@inferred xexpy(x, y)) ≈ x * exp(y)
    end
    for x in (randn(), randn(Float32))
        @test xexpy(x, x) ≈ xexpx(x)
    end
    @test xexpy(0, 1000) == 0.0
    @test isnan(xexpy(0, Inf))
    @test isnan(xexpy(0, NaN))
end

@testset "logistic & logit" begin
    @test logistic(2) ≈ 1.0 / (1.0 + exp(-2.0))
    @test logistic(-750.0) === 0.0
    @test logistic(-740.0) > 0.0
    @test logistic(+36.0) < 1.0
    @test logistic(+750.0) === 1.0
    @test iszero(logit(0.5))
    @test logit(logistic(2)) ≈ 2.0
end

@testset "logcosh and logabssinh" begin
    for x in (randn(), randn(Float32))
        @test @inferred(logcosh(x)) isa typeof(x)
        @test logcosh(x) ≈ log(cosh(x))
        @test logcosh(-x) == logcosh(x)
        @test @inferred(logabssinh(x)) isa typeof(x)
        @test logabssinh(x) ≈ log(abs(sinh(x)))
        @test logabssinh(-x) == logabssinh(x)
    end

    # special values
    for x in (-Inf, Inf, -Inf32, Inf32)
        @test @inferred(logcosh(x)) === oftype(x, Inf)
        @test @inferred(logabssinh(x)) === oftype(x, Inf)
    end
    for x in (NaN, NaN32)
        @test @inferred(logcosh(x)) === x
        @test @inferred(logabssinh(x)) === x
    end
end

@testset "log1psq" begin
    @test iszero(log1psq(0.0))
    @test log1psq(1.0) ≈ log1p(1.0)
    @test log1psq(2.0) ≈ log1p(4.0)
end

# log1pexp, log1mexp, log2mexp & logexpm1

@testset "log1pexp" begin
    for T in (Float16, Float32, Float64, BigFloat), x in 1:40
        @test (@inferred log1pexp(+log(T(x)))) ≈ T(log1p(big(x)))
        @test (@inferred log1pexp(-log(T(x)))) ≈ T(log1p(1/big(x)))
    end

    # special values
    @test (@inferred log1pexp(0)) ≈ log(2)
    @test (@inferred log1pexp(0f0)) ≈ log(2)
    @test (@inferred log1pexp(big(0))) ≈ log(2)
    @test (@inferred log1pexp(+1)) ≈ log1p(ℯ)
    @test (@inferred log1pexp(-1)) ≈ log1p(ℯ) - 1

    # large arguments
    @test (@inferred log1pexp(1e4)) ≈ 1e4
    @test (@inferred log1pexp(1f4)) ≈ 1f4
    @test iszero(@inferred log1pexp(-1e4))
    @test iszero(@inferred log1pexp(-1f4))

    # (almost) zero results
    for T in (Float16, Float32, Float64), x in (log(nextfloat(zero(T))), log(nextfloat(zero(T))) - 1)
        @test @inferred(log1pexp(x)) === log1p(exp(x))
    end

    # hard-coded thresholds
    for T in (Float16, Float32, Float64)
        @test LogExpFunctions._log1pexp_thresholds(zero(T)) === invoke(LogExpFunctions._log1pexp_thresholds, Tuple{Real}, zero(T))
    end

    # compare to accurate but slower implementation
    correct_log1pexp(x::Real) = x > 0 ? x + log1p(exp(-x)) : log1p(exp(x))
    # large range needed to cover all branches, for all floats (from Float16 to BigFloat)
    for T in (Int, Float16, Float32, Float64, BigInt, BigFloat), x in -300:300
        @test (@inferred log1pexp(T(x))) ≈ float(T)(correct_log1pexp(big(x)))
    end
    # test BigFloat with multiple precisions
    for prec in (10, 20, 50, 100), x in -300:300
        setprecision(prec) do
            y = big(float(x))
            @test @inferred(log1pexp(y)) ≈ correct_log1pexp(y)
        end
    end
end

@testset "log1mexp" begin
    for T in (Float64, Float32, Float16)
        @test @inferred(log1mexp(-T(1))) isa T
        @test log1mexp(-T(1))  ≈ log1p(- exp(-T(1)))
        @test log1mexp(-T(10)) ≈ log1p(- exp(-T(10)))
    end
end

@testset "log2mexp" begin
    for T in (Float64, Float32, Float16)
        @test @inferred(log2mexp(T(0))) isa T
        @test iszero(log2mexp(T(0)))
        @test log2mexp(-T(1)) ≈ log(2 - exp(-T(1)))
    end
end

@testset "logexpm1" begin
    for T in (Float64, Float32, Float16)
        @test @inferred(logexpm1(T(2))) isa T
        @test logexpm1(T(2))            ≈  log(exp(T(2)) - 1)
        @test logexpm1(log1pexp(T(2)))  ≈  T(2)
        @test logexpm1(log1pexp(-T(2))) ≈ -T(2)
    end
end

@testset "log1pmx" begin
    @test iszero(log1pmx(0.0))
    @test log1pmx(1.0) ≈ log(2.0) - 1.0
    @test log1pmx(2.0) ≈ log(3.0) - 2.0

    @test iszero(log1pmx(0f0))
    @test log1pmx(1f0) ≈ log(2f0) - 1f0
    @test log1pmx(2f0) ≈ log(3f0) - 2f0

    for x in -0.5:0.1:10
        @test log1pmx(Float32(x)) ≈ Float32(log1pmx(x))
    end
end

@testset "logmxp1" begin
    @test iszero(logmxp1(1.0))
    @test logmxp1(2.0) ≈ log(2.0) - 1.0
    @test logmxp1(3.0) ≈ log(3.0) - 2.0

    @test iszero(logmxp1(1f0))
    @test logmxp1(2f0) ≈ log(2f0) - 1f0
    @test logmxp1(3f0) ≈ log(3f0) - 2f0

    for x in 0.1:0.1:10
        @test logmxp1(Float32(x)) ≈ Float32(logmxp1(x))
    end
end

@testset "logsumexp" begin
    Ts = (Int, Float32, Float64)
    for T1 in Ts, T2 in Ts
        a = T1(2)
        b = T2(3)

        x = @inferred(logaddexp(a, b))
        @test x ≈ log(exp(a) + exp(b))
        @test typeof(x) === float(Base.promote_typeof(a, b))

        y = @inferred(logaddexp(a + 10_000, b + 10_000))
        @test y ≈ 10_000 + log(exp(a) + exp(b))
        @test typeof(y) === typeof(x)
    end

    for x in ([1.0], Complex{Float64}[1.0])
        @test @inferred(logsumexp(x)) == 1.0
        @test @inferred(logsumexp((xi for xi in x))) == 1.0
    end

    for x in ([1.0, 2.0, 3.0], Complex{Float64}[1.0, 2.0, 3.0])
        @test @inferred(logsumexp(x)) ≈ 3.40760596444438
        @test logsumexp(x .+ 1000) ≈ 1003.40760596444438
    end

    for x in ((1.0, 2.0, 3.0), map(complex, (1.0, 2.0, 3.0)))
        @test @inferred(logsumexp(x)) ≈ 3.40760596444438
    end

    _x = [[1.0, 2.0, 3.0] [1.0, 2.0, 3.0] .+ 1000.]
    for x in (_x, complex(_x))
        expected = [3.40760596444438 1003.40760596444438]
        @test @inferred(logsumexp(x; dims=1)) ≈ expected
        out = Array{eltype(x)}(undef, 1, 2)
        @test @inferred(logsumexp!(out, x)) ≈ expected
        @test out ≈ expected

        y = copy(x')
        expected = [3.40760596444438, 1003.40760596444438]
        @test @inferred(logsumexp(y; dims=2)) ≈ expected
        out = Array{eltype(y)}(undef, 2)
        @test @inferred(logsumexp!(out, y)) ≈ expected
        @test out ≈ expected

        expected = [1003.4076059644444]
        @test @inferred(logsumexp(x; dims=[1, 2])) ≈ expected
        out = Array{eltype(x)}(undef, 1)
        @test @inferred(logsumexp!(out, x)) ≈ expected
        @test out ≈ expected
    end

    # check underflow
    @test logsumexp([1e-20, log(1e-20)]) ≈ 2e-20
    @test logsumexp(Complex{Float64}[1e-20, log(1e-20)]) ≈ 2e-20
    @test logsumexp!([1.0], [1e-20, log(1e-20)]) ≈ [2e-20]
    @test logsumexp!(Complex{Float64}[1.0], Complex{Float64}[1e-20, log(1e-20)]) ≈ [2e-20]

    let cases = [([-Inf, -Inf], -Inf),   # correct handling of all -Inf
                 ([-Inf, -Inf32], -Inf), # promotion
                 ([-Inf32, -Inf32], -Inf32), # Float32
                 ([-Inf, Inf], Inf),
                 ([-Inf, 9.0], 9.0),
                 ([Inf, 9.0], Inf),
                 ([0, 0], log(2.0))] # non-float arguments
        for (arguments, result) in cases
            @test logaddexp(arguments...) ≡ result
            @test logsumexp(arguments) ≡ result
            @test logsumexp(complex(arguments)) ≡ complex(result)

            FT = float(eltype(arguments))
            out = [one(FT)]
            @test logsumexp!(out, arguments)[1] ≡ result
            @test out[1] ≡ result

            out = [one(complex(FT))]
            @test logsumexp!(out, complex(arguments))[1] ≡ complex(result)
            @test out[1] ≡ complex(result)
        end
    end

    @test isnan(logsubexp(Inf, Inf))
    @test logsubexp(-Inf, -Inf) ≡ -Inf
    @test logsubexp(Inf, -Inf) ≡ Inf
    @test logsubexp(-Inf, Inf) ≡ Inf
    @test logsubexp(Inf, 9.0) ≡ Inf
    @test logsubexp(9.0, Inf) ≡ Inf
    @test logsubexp(-Inf, 9.0) ≡ 9.0
    @test logsubexp(9.0, -Inf) ≡ 9.0
    @test logsubexp(1f2, 1f2) ≡ -Inf32
    @test logsubexp(0, 0) ≡ -Inf
    @test logsubexp(3, 2) ≈ 2.541324854612918108978

    # NaN propagation
    for f in (logaddexp, logsubexp)
        @test isnan(f(NaN, 9.0))
        @test isnan(f(NaN, Inf))
        @test isnan(f(NaN, -Inf))
        @test isnan(f(9.0, NaN))
        @test isnan(f(Inf, NaN))
        @test isnan(f(-Inf, NaN))
    end

    @test isnan(logsumexp([NaN, 9.0]))
    @test isnan(logsumexp([NaN, Inf]))
    @test isnan(logsumexp([NaN, -Inf]))
    @test isnan(logsumexp(Complex{Float64}[NaN, 9.0]))
    @test isnan(logsumexp(Complex{Float64}[NaN, Inf]))
    @test isnan(logsumexp(Complex{Float64}[NaN, -Inf]))
    @test isnan(logsumexp(Complex{Float64}[NaN * im, 9.0]))
    @test isnan(logsumexp(Complex{Float64}[NaN * im, Inf]))
    @test isnan(logsumexp(Complex{Float64}[NaN * im, -Inf]))
    @test isnan(logsumexp!([1.0], [NaN, 9.0])[1])
    @test isnan(logsumexp!([1.0], [NaN, Inf])[1])
    @test isnan(logsumexp!([1.0], [NaN, -Inf])[1])
    @test isnan(logsumexp!(Complex{Float64}[1.0], Complex{Float64}[NaN, 9.0])[1])
    @test isnan(logsumexp!(Complex{Float64}[1.0], Complex{Float64}[NaN, Inf])[1])
    @test isnan(logsumexp!(Complex{Float64}[1.0], Complex{Float64}[NaN, -Inf])[1])
    @test isnan(logsumexp!(Complex{Float64}[1.0], Complex{Float64}[NaN * im, 9.0])[1])
    @test isnan(logsumexp!(Complex{Float64}[1.0], Complex{Float64}[NaN * im, Inf])[1])
    @test isnan(logsumexp!(Complex{Float64}[1.0], Complex{Float64}[NaN * im, -Inf])[1])

    # logsumexp with general iterables (issue #63)
    xs = range(-500, stop = 10, length = 1000)
    @test @inferred(logsumexp(x for x in xs)) == logsumexp(xs)
    xs = range(-500 + 0.5im, stop = 10 + 30im, length = 1000)
    @test @inferred(logsumexp(x for x in xs)) == logsumexp(xs)

    # complex numbers
    xs = randn(Complex{Float64}, 10, 5)
    @test @inferred(logsumexp(xs)) ≈ log(sum(exp.(xs)))
    @test @inferred(logsumexp(xs; dims=1)) ≈ log.(sum(exp.(xs); dims=1))
    @test @inferred(logsumexp(xs; dims=2)) ≈ log.(sum(exp.(xs); dims=2))
    @test @inferred(logsumexp(xs; dims=[1, 2])) ≈ log(sum(exp.(xs); dims=[1, 2]))
    @test @inferred(logsumexp(x for x in xs)) == logsumexp(xs)

    # output arrays with abstract eltype
    xs = randn(2, 4)
    out = [missing, 1.0]
    expected = logsumexp(xs; dims=2)
    @test logsumexp!(out, xs) ≈ expected
    @test out ≈ expected

    @testset "ForwardDiff" begin
        # vector with finite numbers
        x = randn(10)
        ∇x = unthunk(rrule(logsumexp, x)[2](1)[2])
        @test ForwardDiff.gradient(logsumexp, x) ≈ ∇x

        # issue #59
        x = vcat(-Inf, randn(9))
        ∇x = unthunk(rrule(logsumexp, x)[2](1)[2])
        @assert all(isfinite, ∇x)
        @test ForwardDiff.gradient(logsumexp, x) ≈ ∇x
    end
end

@testset "softmax" begin
    x = [1.0, 2.0, 3.0]
    r = exp.(x) ./ sum(exp.(x))

    # in-place versions
    for T in (Float32, Float64)
        s = Vector{T}(undef, 3)
        softmax!(s, x)
        @test s ≈ r

        fill!(s, zero(T))
        softmax!(s, x; dims=1)
        @test s ≈ r

        s = Matrix{T}(undef, 1, 3)
        softmax!(s, x)
        @test s ≈ permutedims(r)

        @test_throws DimensionMismatch softmax!(s, x; dims=1)

        fill!(s, zero(T))
        softmax!(s, permutedims(x); dims=2)
        @test s ≈ permutedims(r)

        fill!(s, zero(T))
        softmax!(s, permutedims(x); dims=1:2)
        @test s ≈ permutedims(r)
    end
    softmax!(x)
    @test x ≈ r

    for (S, T) in ((Int, Float64), (Float64, Float64), (Float32, Float32))
        x = S[1, 2, 3]
        s = softmax(x)
        @test s ≈ r
        @test eltype(s) === T

        x = repeat(S[1, 2, 3], 1, 3)
        s = softmax(x; dims=1)
        @test s ≈ repeat(r, 1, 3)
        @test eltype(s) === T

        x = repeat(S[1 2 3], 3, 1)
        s = softmax(x; dims=2)
        @test s ≈ repeat(permutedims(r), 3, 1)
        @test eltype(s) === T

        x = S[1 2 3]
        s = softmax(x; dims=1:2)
        @test s ≈ permutedims(r)
        @test eltype(s) === T
    end

    x = [1//2, 2//3, 3//4]
    r = exp.(x) ./ sum(exp.(x))
    s = softmax(x)
    @test s ≈ r
    @test eltype(s) === Float64

    # non-standard indices: #12
    x = OffsetArray(1:3, -2:0)
    s = softmax(x)
    @test s isa OffsetArray{Float64}
    @test axes(s, 1) == OffsetArrays.IdOffsetRange(-2:0)
    @test collect(s) ≈ softmax(1:3)
end

@testset "cloglog and cexpexp" begin
    cloglog_big(x::T) where {T} = T(log(-log(1 - BigFloat(x))))
    cexpexp_big(x::T) where {T} = 1 - exp(-exp(BigFloat(x)))

    for T in (Float64, Float32, Float16)
        @test @inferred(cloglog(T(1//2))) isa T
        @test @inferred(cexpexp(T(0))) isa T
        for x in 0.1:0.1:0.9
            @test cloglog(T(x)) ≈ cloglog_big(T(x))
            # Julia bug for Float32 and Float16 initially introduced in https://github.com/JuliaLang/julia/pull/37440
            # and fixed in https://github.com/JuliaLang/julia/pull/50989
            if T === Float64 || VERSION < v"1.7.0-DEV.887" || VERSION >= v"1.11.0-DEV.310"
                @test cexpexp(T(x)) ≈ cexpexp_big(T(x))
            end
        end
    end
    for _ in 1:10
        randf = rand(Float64)
        @test cloglog(randf) ≈ cloglog_big(randf)
        randi = rand(Int)
        @test cexpexp(randi) ≈ cexpexp_big(randi)
    end

    @test cloglog(0) == -Inf
    @test cloglog(1) == Inf
    @test cloglog((ℯ - 1) / ℯ) == 0

    @test cexpexp(Inf) == 1.0
    @test cexpexp(-Inf) == 0.0
    @test cexpexp(0) == (ℯ - 1) / ℯ
end

@testset "loglogistic: $T" for T in (Float16, Float32, Float64)
    lim1 = T === Float16 ? -14.0 : -50.0
    lim2 = T === Float16 ? -10.0 : -37.0
    xs = T[Inf, -Inf, 0.0, lim1, lim2]
    for x in xs
        @test loglogistic(x) == log(logistic(x))
    end

    ϵ = eps(T)
    xs = T[ϵ, 1.0, 18.0, 33.3, 50.0]
    for x in xs
        lhs = loglogistic(x)
        rhs = log(logistic(x))
        @test abs(lhs - rhs) < ϵ
    end

    # misc
    @test loglogistic(T(Inf)) == -zero(T)
    @test loglogistic(-T(Inf)) == -T(Inf)
    @test loglogistic(-T(103.0)) == -T(103.0)
    @test abs(loglogistic(T(35.0))) < 3eps(T)
    @test abs(loglogistic(T(103.0))) < eps(T)
    @test isfinite(loglogistic(-T(745.0)))
    @test isfinite(loglogistic(T(50.0)))
    @test isfinite(loglogistic(T(745.0)))
    @test isnan(loglogistic(T(NaN)))
    @test isnan(loglogistic(T(-NaN)))

    # type-consistency
    xs = T[Inf, -Inf, 0.0, lim1, lim2, ϵ, 1.0, 18.0, 33.3, 50.0]
    for x in xs
        @test typeof(loglogistic(x)) === T
    end
end


@testset "logitexp: $T" for T in (Float16, Float32, Float64)
    ϵ = eps(T)
    xs = T[ϵ, √ϵ, 0.2, 0.4, 0.8, 1.0 - √ϵ, 1.0 - ϵ]
    neg_xs = -xs
    for x in xs
        @test abs(logitexp(loglogistic(x)) - x) <= ϵ
    end
    for x in neg_xs
        @test abs(logitexp(loglogistic(x)) - x) <= 2ϵ
    end
    xs = T[-Inf, 0.0, Inf]
    for x in xs
        @test logitexp(loglogistic(x)) == x
    end

    # misc
    @test isnan(logitexp(T(NaN)))
    @test isnan(logitexp(T(-NaN)))

    # type-consistency
    xs = loglogistic.([T[ϵ, √ϵ, 0.2, 0.4, 0.8, 1.0 - √ϵ, 1.0 - ϵ]; neg_xs; T[-Inf, 0.0, Inf]])
    for x in xs
        @test typeof(logitexp(x)) === T
    end
end

@testset "log1mlogistic: $T" for T in (Float16, Float32, Float64)
    @test log1mlogistic(T(Inf)) == -T(Inf)
    @test log1mlogistic(-T(Inf)) == -zero(T)
    @test log1mlogistic(-T(103.0)) < eps(T)
    @test abs(log1mlogistic(T(35.0))) == T(35.0)
    @test abs(log1mlogistic(T(103.0))) == T(103.0)
    @test isfinite(log1mlogistic(-T(745.0)))
    @test isfinite(log1mlogistic(T(50.0)))
    @test isfinite(log1mlogistic(T(745.0)))
    @test isnan(log1mlogistic(T(NaN)))
    @test isnan(log1mlogistic(T(-NaN)))

    # type-consistency
    ϵ = eps(T)
    lim1 = T === Float16 ? -14.0 : -50.0
    lim2 = T === Float16 ? -10.0 : -37.0
    xs = T[Inf, -Inf, 0.0, lim1, lim2, ϵ, 1.0, 18.0, 33.3, 50.0]
    for x in xs
        @test typeof(log1mlogistic(x)) === T
    end
end


@testset "logit1mexp: $T" for T in (Float16, Float32, Float64)
    ϵ = eps(T)
    xs = T[ϵ, √ϵ, 0.2, 0.4, 0.8, 1.0 - √ϵ, 1.0 - ϵ]
    neg_xs = -xs
    for x in xs
        @test abs(logit1mexp(log1mlogistic(x)) - x) <= 2ϵ
    end
    for x in neg_xs
        @test abs(logit1mexp(log1mlogistic(x)) - x) <= ϵ
    end
    xs = T[-Inf, 0.0, Inf]
    for x in xs
        @test logit1mexp(log1mlogistic(x)) == x
    end

    # misc
    @test isnan(logit1mexp(T(NaN)))
    @test isnan(logit1mexp(T(-NaN)))

    # type-consistency
    xs = log1mlogistic.([T[ϵ, √ϵ, 0.2, 0.4, 0.8, 1.0 - √ϵ, 1.0 - ϵ]; neg_xs; T[-Inf, 0.0, Inf]])
    for x in xs
        @test typeof(logit1mexp(x)) === T
    end
end

@testset "loglogistic, log1mlogistic correctness wrt Unsigned, Rational: $T" for T in
    (UInt8, UInt16, UInt32, UInt64, UInt128)
    @test loglogistic(T(5)) == loglogistic(5.0)
    @test log1mlogistic(T(5)) == log1mlogistic(5.0)

    @test loglogistic(T(0x01)//T(0x02)) == loglogistic(0.5)
    @test log1mlogistic(T(0x01)//T(0x02)) == log1mlogistic(0.5)

    @test loglogistic(T(0x01)//T(0x00)) == loglogistic(Inf)
    @test log1mlogistic(T(0x01)//T(0x00)) == log1mlogistic(Inf)

end

@testset "loglogistic, log1mlogistic, logitexp, logit1mexp correctness wrt Integer edge case: $T" for T in
    (Int8, Int16, Int32, Int64, Int128)
    # If not handled, these will be zero
    @test loglogistic(typemin(T)) == loglogistic(float(typemin(T)))
    @test log1mlogistic(typemin(T)) == log1mlogistic(float(typemin(T)))

    # If not handled, these would throw since negation at typemin is a round-trip
    @test logitexp(typemin(T)) == logitexp(float(typemin(T)))
    @test logit1mexp(typemin(T)) == logit1mexp(float(typemin(T)))
end

@testset "loglogistic, log1mlogistic, logitexp, logit1mexp return types" begin
    for T in
        (UInt8, UInt16, UInt32, UInt64, UInt128, Int8, Int16, Int32, Int64, Int128)
        @test typeof(loglogistic(T(5))) === Float64
        @test typeof(log1mlogistic(T(5))) === Float64
        @test typeof(loglogistic(T(0x01)//T(0x02))) === Float64
        @test typeof(log1mlogistic(T(0x01)//T(0x02))) === Float64
        @test typeof(logitexp(T(0))) === Float64
        @test typeof(logit1mexp(T(0))) === Float64
    end
    @test typeof(loglogistic(BigInt(5))) === BigFloat
    @test typeof(log1mlogistic(BigInt(5))) === BigFloat
    @test typeof(loglogistic(BigInt(0x01)//BigInt(0x02))) === BigFloat
    @test typeof(log1mlogistic(BigInt(0x01)//BigInt(0x02))) === BigFloat
    @test typeof(logitexp(BigInt(0))) === BigFloat
    @test typeof(logit1mexp(BigInt(0))) === BigFloat

    @test typeof(loglogistic(BigFloat(5))) === BigFloat
    @test typeof(log1mlogistic(BigFloat(5))) === BigFloat
    @test typeof(logitexp(BigFloat(0))) === BigFloat
    @test typeof(logit1mexp(BigFloat(0))) === BigFloat
end

@testset "chainrules.jl" begin
    x = rand()
    test_frule(xlogx, x)
    test_rrule(xlogx, x)

    # Test `iszero(x)` branches
    test_frule(xlogy, 0.0, 1.0; fdm = forward_fdm(5, 1), nans = true)
    test_rrule(xlogy, 0.0, 1.0; fdm = forward_fdm(5, 1), nans = true)
    @test iszero(last(frule((NoTangent(), ZeroTangent(), 1.), xlog1py, 0.0, -1.0)))
    @test iszero(last(last(rrule(xlog1py, 0.0, -1.0))(1.)))

    for x in (-x, 0.0, x)
        y = rand()
        test_frule(xlogy, x, y)
        test_rrule(xlogy, x, y)

        for z in (-y, y)
            test_frule(xlog1py, x, z)
            test_rrule(xlog1py, x, z)
        end
    end

    @testset "xexpx" begin
        # regular branch
        test_scalar(xexpx, randn())
        # special cases (manually since FiniteDifferences/ChainRulesTestUtils fails at -Inf)
        @test @inferred(frule((NoTangent(), rand()), xexpx, -Inf)) === (0.0, 0.0)
        Ω, back = @inferred(rrule(xexpx, -Inf))
        @test Ω === 0.0
        @test back(rand()) === (NoTangent(), 0.0)
    end

    @testset "xexpy" begin
        # regular branch
        test_frule(xexpy, randn(), randn())
        test_rrule(xexpy, randn(), randn())
        # special cases (manually since FiniteDifferences/ChainRulesTestUtils fails at -Inf)
        @test @inferred(frule((NoTangent(), rand(), rand()), xexpy, x, -Inf)) === (0.0, 0.0)
        Ω, back = @inferred(rrule(xexpy, x, -Inf))
        @test Ω === 0.0
        @test back(rand()) === (NoTangent(), 0.0, 0.0)
    end

    test_frule(logit, x)
    test_rrule(logit, x)

    for x in (-randexp(), randexp())
        test_frule(log1psq, x)
        test_rrule(log1psq, x)
    end

    # test all `Float64` and `Float32` branches of `logistic`
    for x in (-821.4, -23.5, 12.3, 41.2)
        test_frule(logistic, x)
        test_rrule(logistic, x)
    end
    for x in (-123.2f0, -21.4f0, 8.3f0, 21.5f0)
        test_frule(logistic, x; rtol=1f-3, atol=1f-3)
        test_rrule(logistic, x; rtol=1f-3, atol=1f-3)
    end

    for x in (-randexp(), randexp())
        test_frule(logcosh, x)
        test_rrule(logcosh, x)
        test_frule(logabssinh, x)
        test_rrule(logabssinh, x)
    end

    @testset "log1pexp" begin
        for absx in (0, 1, 2, 10, 15, 20, 40), x in (-absx, absx)
            test_scalar(log1pexp, Float64(x))
            test_scalar(log1pexp, Float32(x); rtol=1f-3, atol=1f-3)
        end
    end

    for x in (-10.2, -3.3, -0.3)
        test_frule(log1mexp, x)
        test_rrule(log1mexp, x)
    end

    for x in (-10.2, -3.3, -0.3, 0.5)
        test_frule(log2mexp, x)
        test_rrule(log2mexp, x)
    end

    # test all branches of `logexpm1`
    for x in (5.2, 21.4, 41.5)
        test_frule(logexpm1, x)
        test_rrule(logexpm1, x)
    end
    for x in (4.3f0, 12.5f0, 21.2f0)
        test_frule(logexpm1, x; rtol=1f-3, atol=1f-3)
        test_rrule(logexpm1, x; rtol=1f-3, atol=1f-3)
    end

    test_scalar(log1pmx, rand())

    test_scalar(logmxp1, 0.5 + rand())

    for x in (-randexp(), randexp()), y in (-randexp(), randexp())
        test_frule(logaddexp, x, y)
        test_rrule(logaddexp, x, y)

        test_frule(logsubexp, x, y)
        test_rrule(logsubexp, x, y)
    end

    for x in (randn(10), randn(10, 8)), dims in (:, 1, 1:2, 2)
        dims isa Colon || all(d <= ndims(x) for d in dims) || continue
        test_frule(logsumexp, x; fkwargs=(dims=dims,))
        test_rrule(logsumexp, x; fkwargs=(dims=dims,))
    end

    for x in (randn(10), randn(10, 8))
        test_frule(softmax, x)
        test_rrule(softmax, x)

        for dims in (1, 1:2, 2)
            all(d <= ndims(x) for d in dims) || continue
            test_frule(softmax, x; fkwargs=(dims=dims,))
            test_rrule(softmax, x; fkwargs=(dims=dims,))
        end
    end

    test_scalar(cloglog, rand())

    test_scalar(cexpexp, rand())
end

using Documenter, LogExpFunctions

# Doctest setup
DocMeta.setdocmeta!(
    LogExpFunctions, :DocTestSetup, :(using LogExpFunctions); recursive=true
)

makedocs(;
    modules=[LogExpFunctions],
    format=Documenter.HTML(),
    sitename="LogExpFunctions.jl",
    pages=Any["index.md"],
    checkdocs=:exports,
    strict=true,
)

deploydocs(; repo="github.com/JuliaStats/LogExpFunctions.jl.git")

module LogExpFunctionsInverseFunctionsExt

using LogExpFunctions
import InverseFunctions

InverseFunctions.inverse(::typeof(log1pexp)) = logexpm1
InverseFunctions.inverse(::typeof(logexpm1)) = log1pexp

InverseFunctions.inverse(::typeof(log1mexp)) = log1mexp

InverseFunctions.inverse(::typeof(log2mexp)) = log2mexp

InverseFunctions.inverse(::typeof(logit)) = logistic
InverseFunctions.inverse(::typeof(logistic)) = logit

InverseFunctions.inverse(::typeof(cloglog)) = cexpexp
InverseFunctions.inverse(::typeof(cexpexp)) = cloglog

InverseFunctions.inverse(::typeof(loglogistic)) = logitexp
InverseFunctions.inverse(::typeof(logitexp)) = loglogistic

InverseFunctions.inverse(::typeof(log1mlogistic)) = logit1mexp
InverseFunctions.inverse(::typeof(logit1mexp)) = log1mlogistic

InverseFunctions.inverse(::typeof(softplus)) = invsoftplus
function InverseFunctions.inverse(f::Base.Fix2{typeof(softplus),<:Real})
    Base.Fix2(invsoftplus, f.x)
end

InverseFunctions.inverse(::typeof(invsoftplus)) = softplus
function InverseFunctions.inverse(f::Base.Fix2{typeof(invsoftplus),<:Real})
    Base.Fix2(softplus, f.x)
end

end # module

@testset "with_logabsdet_jacobian" begin
    derivative(f, x) = ChainRulesTestUtils.frule((ChainRulesTestUtils.NoTangent(), 1), f, x)[2]

    x = randexp()

    ChangesOfVariables.test_with_logabsdet_jacobian(log1pexp, x, derivative)
    ChangesOfVariables.test_with_logabsdet_jacobian(log1pexp, -x, derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(logexpm1, x, derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(log1mexp, -x, derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(log2mexp, log(2) - x, derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(logistic, -x, derivative)
    ChangesOfVariables.test_with_logabsdet_jacobian(logistic, x, derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(logit, rand(), derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(logcosh, x, derivative)
    ChangesOfVariables.test_with_logabsdet_jacobian(logcosh, -x, derivative)

    dloglogistic(x) = logistic(-x)
    dlog1mlogistic(x) = -logistic(x)
    dlogitexp(x) = inv(1 - exp(x))
    dlogit1mexp(x) = -inv(1 - exp(x))
    derivative(f::typeof(loglogistic), x) = dloglogistic(x)
    derivative(f::typeof(log1mlogistic), x) = dlog1mlogistic(x)
    derivative(f::typeof(logitexp), x) = dlogitexp(x)
    derivative(f::typeof(logit1mexp), x) = dlogit1mexp(x)

    ChangesOfVariables.test_with_logabsdet_jacobian(loglogistic, x, derivative)
    ChangesOfVariables.test_with_logabsdet_jacobian(logitexp, -x, derivative)

    ChangesOfVariables.test_with_logabsdet_jacobian(log1mlogistic, x, derivative)
    ChangesOfVariables.test_with_logabsdet_jacobian(logit1mexp, -x, derivative)
end

# LogExpFunctions

Various special functions based on `log` and `exp` moved from [StatsFuns.jl](https://github.com/JuliaStats/StatsFuns.jl) into a separate package, to minimize dependencies. These functions only use native Julia code, so there is no need to depend on `librmath` or similar libraries. See the discussion at [StatsFuns.jl#46](https://github.com/JuliaStats/StatsFuns.jl/issues/46).

The original authors of these functions are the StatsFuns.jl contributors.

LogExpFunctions supports [`InverseFunctions.inverse`](https://github.com/JuliaMath/InverseFunctions.jl) and [`ChangesOfVariables.test_with_logabsdet_jacobian`](https://github.com/JuliaMath/ChangesOfVariables.jl) for `log1mexp`, `log1pexp`, `log2mexp`, `logexpm1`, `logistic`, `logit`, `loglogistic`, `logitexp`, `log1mlogistic`, `logit1mexp`, and `logcosh` (no inverse).

```@docs
xlogx
xlogy
xlog1py
xexpx
xexpy
logistic
logit
logcosh
logabssinh
logabstanh
log1psq
log1pexp
softplus
invsoftplus
log1mexp
log2mexp
logexpm1
log1pmx
logmxp1
logaddexp
logsubexp
logsumexp
logsumexp!
softmax!
softmax
cloglog
cexpexp
loglogistic
logitexp
log1mlogistic
logit1mexp
```
